import { OnDestroy } from '@angular/core';
import { Observable } from 'rxjs';
import { Manager, Socket } from 'socket.io-client';
import { SocketioConfig } from './socketio.interface';
export declare class Socketio implements OnDestroy {
    private subject;
    private socket;
    get id(): string;
    get connected(): boolean;
    get disconnected(): boolean;
    get io(): Manager;
    get auth(): Socket['auth'];
    constructor({ url, options }: SocketioConfig);
    ngOnDestroy(): void;
    connect(): this;
    disconnect(): this;
    send(...args: any[]): this;
    emit(eventName: string, ...args: any[]): this;
    on<T>(): Observable<{
        eventName: string;
        args: T;
    }>;
    on<T>(eventName?: string): Observable<T>;
    once<T>(eventName: string): Observable<T>;
    compress(compress: boolean): this;
}
